--- old/usr/src/cmd/sendmail/libsm/rpool.c	Sat Feb  6 15:36:38 2016
+++ new/usr/src/cmd/sendmail/libsm/rpool.c	Sat Feb  6 15:36:38 2016
@@ -1,5 +1,5 @@
 /*
- * Copyright (c) 2000-2004 Sendmail, Inc. and its suppliers.
+ * Copyright (c) 2000-2004 Proofpoint, Inc. and its suppliers.
  *	All rights reserved.
  *
  * By using this file, you agree to the terms and conditions set
@@ -7,10 +7,8 @@
  * the sendmail distribution.
  */
 
-#pragma ident	"%Z%%M%	%I%	%E% SMI"
-
 #include <sm/gen.h>
-SM_RCSID("@(#)$Id: rpool.c,v 1.28 2004/08/03 20:44:04 ca Exp $")
+SM_RCSID("@(#)$Id: rpool.c,v 1.29 2013-11-22 20:51:43 ca Exp $")
 
 /*
 **  resource pools
--- old/usr/src/cmd/sendmail/libsm/sem.c	Sat Feb  6 15:36:38 2016
+++ new/usr/src/cmd/sendmail/libsm/sem.c	Sat Feb  6 15:36:38 2016
@@ -1,5 +1,5 @@
 /*
- * Copyright (c) 2000-2001, 2005, 2008 Sendmail, Inc. and its suppliers.
+ * Copyright (c) 2000-2001, 2005, 2008 Proofpoint, Inc. and its suppliers.
  *      All rights reserved.
  *
  * By using this file, you agree to the terms and conditions set
@@ -8,7 +8,7 @@
  */
 
 #include <sm/gen.h>
-SM_RCSID("@(#)$Id: sem.c,v 1.14 2008/05/30 16:26:38 ca Exp $")
+SM_RCSID("@(#)$Id: sem.c,v 1.15 2013-11-22 20:51:43 ca Exp $")
 
 #if SM_CONF_SEM
 # include <stdlib.h>
--- old/usr/src/cmd/sendmail/libsm/setvbuf.c	Sat Feb  6 15:36:38 2016
+++ new/usr/src/cmd/sendmail/libsm/setvbuf.c	Sat Feb  6 15:36:38 2016
@@ -1,5 +1,5 @@
 /*
- * Copyright (c) 2000-2001 Sendmail, Inc. and its suppliers.
+ * Copyright (c) 2000-2001 Proofpoint, Inc. and its suppliers.
  *      All rights reserved.
  * Copyright (c) 1990, 1993
  *	The Regents of the University of California.  All rights reserved.
@@ -12,10 +12,8 @@
  * the sendmail distribution.
  */
 
-#pragma ident	"%Z%%M%	%I%	%E% SMI"
-
 #include <sm/gen.h>
-SM_RCSID("@(#)$Id: setvbuf.c,v 1.30 2001/02/28 20:25:18 rodney Exp $")
+SM_RCSID("@(#)$Id: setvbuf.c,v 1.33 2013-11-22 20:51:43 ca Exp $")
 #include <stdlib.h>
 #include <errno.h>
 #include <fcntl.h>
--- old/usr/src/cmd/sendmail/libsm/shm.c	Sat Feb  6 15:36:38 2016
+++ new/usr/src/cmd/sendmail/libsm/shm.c	Sat Feb  6 15:36:38 2016
@@ -1,5 +1,5 @@
 /*
- * Copyright (c) 2000-2001, 2003, 2005 Sendmail, Inc. and its suppliers.
+ * Copyright (c) 2000-2001, 2003, 2005 Proofpoint, Inc. and its suppliers.
  *      All rights reserved.
  *
  * By using this file, you agree to the terms and conditions set
@@ -7,10 +7,8 @@
  * the sendmail distribution.
  */
 
-#pragma ident	"%Z%%M%	%I%	%E% SMI"
-
 #include <sm/gen.h>
-SM_RCSID("@(#)$Id: shm.c,v 1.19 2005/07/14 22:34:28 ca Exp $")
+SM_RCSID("@(#)$Id: shm.c,v 1.20 2013-11-22 20:51:43 ca Exp $")
 
 #if SM_CONF_SHM
 # include <stdlib.h>
--- old/usr/src/cmd/sendmail/libsm/signal.c	Sat Feb  6 15:36:38 2016
+++ new/usr/src/cmd/sendmail/libsm/signal.c	Sat Feb  6 15:36:38 2016
@@ -1,5 +1,5 @@
 /*
- * Copyright (c) 2000-2001 Sendmail, Inc. and its suppliers.
+ * Copyright (c) 2000-2001 Proofpoint, Inc. and its suppliers.
  *      All rights reserved.
  *
  * By using this file, you agree to the terms and conditions set
@@ -7,10 +7,8 @@
  * the sendmail distribution.
  */
 
-#pragma ident	"%Z%%M%	%I%	%E% SMI"
-
 #include <sm/gen.h>
-SM_RCSID("@(#)$Id: signal.c,v 1.17 2005/06/14 23:07:20 ca Exp $")
+SM_RCSID("@(#)$Id: signal.c,v 1.18 2013-11-22 20:51:43 ca Exp $")
 
 #if SM_CONF_SETITIMER
 # include <sm/time.h>
--- old/usr/src/cmd/sendmail/libsm/smstdio.c	Sat Feb  6 15:36:38 2016
+++ new/usr/src/cmd/sendmail/libsm/smstdio.c	Sat Feb  6 15:36:38 2016
@@ -1,5 +1,5 @@
 /*
- * Copyright (c) 2000-2002, 2004 Sendmail, Inc. and its suppliers.
+ * Copyright (c) 2000-2002, 2004 Proofpoint, Inc. and its suppliers.
  *      All rights reserved.
  *
  * By using this file, you agree to the terms and conditions set
@@ -7,10 +7,8 @@
  * the sendmail distribution.
  */
 
-#pragma ident	"%Z%%M%	%I%	%E% SMI"
-
 #include <sm/gen.h>
-SM_IDSTR(id, "@(#)$Id: smstdio.c,v 1.34 2004/08/03 20:46:34 ca Exp $")
+SM_IDSTR(id, "@(#)$Id: smstdio.c,v 1.35 2013-11-22 20:51:43 ca Exp $")
 #include <unistd.h>
 #include <stdio.h>
 #include <fcntl.h>
--- old/usr/src/cmd/sendmail/libsm/snprintf.c	Sat Feb  6 15:36:38 2016
+++ new/usr/src/cmd/sendmail/libsm/snprintf.c	Sat Feb  6 15:36:38 2016
@@ -1,5 +1,5 @@
 /*
- * Copyright (c) 2000-2001 Sendmail, Inc. and its suppliers.
+ * Copyright (c) 2000-2001 Proofpoint, Inc. and its suppliers.
  *      All rights reserved.
  * Copyright (c) 1990, 1993
  *	The Regents of the University of California.  All rights reserved.
@@ -12,10 +12,8 @@
  * the sendmail distribution.
  */
 
-#pragma ident	"%Z%%M%	%I%	%E% SMI"
-
 #include <sm/gen.h>
-SM_RCSID("@(#)$Id: snprintf.c,v 1.24 2006/10/12 21:50:10 ca Exp $")
+SM_RCSID("@(#)$Id: snprintf.c,v 1.25 2013-11-22 20:51:43 ca Exp $")
 #include <limits.h>
 #include <sm/varargs.h>
 #include <sm/io.h>
--- old/usr/src/cmd/sendmail/libsm/sscanf.c	Sat Feb  6 15:36:39 2016
+++ new/usr/src/cmd/sendmail/libsm/sscanf.c	Sat Feb  6 15:36:39 2016
@@ -1,5 +1,5 @@
 /*
- * Copyright (c) 2000-2001 Sendmail, Inc. and its suppliers.
+ * Copyright (c) 2000-2001 Proofpoint, Inc. and its suppliers.
  *      All rights reserved.
  * Copyright (c) 1990, 1993
  *	The Regents of the University of California.  All rights reserved.
@@ -12,10 +12,8 @@
  * the sendmail distribution.
  */
 
-#pragma ident	"%Z%%M%	%I%	%E% SMI"
-
 #include <sm/gen.h>
-SM_RCSID("@(#)$Id: sscanf.c,v 1.25 2002/02/01 02:28:00 ca Exp $")
+SM_RCSID("@(#)$Id: sscanf.c,v 1.26 2013-11-22 20:51:43 ca Exp $")
 #include <string.h>
 #include <sm/varargs.h>
 #include <sm/io.h>
--- old/usr/src/cmd/sendmail/libsm/stdio.c	Sat Feb  6 15:36:39 2016
+++ new/usr/src/cmd/sendmail/libsm/stdio.c	Sat Feb  6 15:36:39 2016
@@ -1,5 +1,5 @@
 /*
- * Copyright (c) 2000-2005 Sendmail, Inc. and its suppliers.
+ * Copyright (c) 2000-2005 Proofpoint, Inc. and its suppliers.
  *      All rights reserved.
  * Copyright (c) 1990, 1993
  *	The Regents of the University of California.  All rights reserved.
@@ -12,10 +12,8 @@
  * the sendmail distribution.
  */
 
-#pragma ident	"%Z%%M%	%I%	%E% SMI"
-
 #include <sm/gen.h>
-SM_RCSID("@(#)$Id: stdio.c,v 1.71 2005/06/14 23:07:20 ca Exp $")
+SM_RCSID("@(#)$Id: stdio.c,v 1.72 2013-11-22 20:51:43 ca Exp $")
 #include <unistd.h>
 #include <errno.h>
 #include <fcntl.h>
--- old/usr/src/cmd/sendmail/libsm/strcasecmp.c	Sat Feb  6 15:36:39 2016
+++ new/usr/src/cmd/sendmail/libsm/strcasecmp.c	Sat Feb  6 15:36:39 2016
@@ -1,5 +1,5 @@
 /*
- * Copyright (c) 2000-2001 Sendmail, Inc. and its suppliers.
+ * Copyright (c) 2000-2001 Proofpoint, Inc. and its suppliers.
  *	All rights reserved.
  * Copyright (c) 1983, 1995-1997 Eric P. Allman.  All rights reserved.
  * Copyright (c) 1987, 1988, 1993
@@ -11,16 +11,14 @@
  *
  */
 
-#pragma ident	"%Z%%M%	%I%	%E% SMI"
-
 #include <sm/gen.h>
-SM_RCSID("@(#)$Id: strcasecmp.c,v 1.12 2001/08/27 22:09:15 gshapiro Exp $")
+SM_RCSID("@(#)$Id: strcasecmp.c,v 1.16 2013-11-22 20:51:43 ca Exp $")
 
 #include <sm/config.h>
 #include <sm/string.h>
 #include <string.h>
 
-/*
+/*
 **  SM_STRCASECMP -- 8-bit clean version of strcasecmp
 **
 **	Thank you, vendors, for making this all necessary.
--- old/usr/src/cmd/sendmail/libsm/strdup.c	Sat Feb  6 15:36:39 2016
+++ new/usr/src/cmd/sendmail/libsm/strdup.c	Sat Feb  6 15:36:39 2016
@@ -1,5 +1,5 @@
 /*
- * Copyright (c) 2000-2001, 2003 Sendmail, Inc. and its suppliers.
+ * Copyright (c) 2000-2001, 2003 Proofpoint, Inc. and its suppliers.
  *	All rights reserved.
  *
  * By using this file, you agree to the terms and conditions set
@@ -8,10 +8,8 @@
  *
  */
 
-#pragma ident	"%Z%%M%	%I%	%E% SMI"
-
 #include <sm/gen.h>
-SM_RCSID("@(#)$Id: strdup.c,v 1.15 2003/10/10 17:56:57 ca Exp $")
+SM_RCSID("@(#)$Id: strdup.c,v 1.16 2013-11-22 20:51:43 ca Exp $")
 
 #include <sm/heap.h>
 #include <sm/string.h>
--- old/usr/src/cmd/sendmail/libsm/strerror.c	Sat Feb  6 15:36:39 2016
+++ new/usr/src/cmd/sendmail/libsm/strerror.c	Sat Feb  6 15:36:39 2016
@@ -1,5 +1,5 @@
 /*
- * Copyright (c) 2000-2001 Sendmail, Inc. and its suppliers.
+ * Copyright (c) 2000-2001 Proofpoint, Inc. and its suppliers.
  *	All rights reserved.
  * Copyright (c) 1983, 1995-1997 Eric P. Allman.  All rights reserved.
  * Copyright (c) 1988, 1993
@@ -11,10 +11,8 @@
  *
  */
 
-#pragma ident	"%Z%%M%	%I%	%E% SMI"
-
 #include <sm/gen.h>
-SM_RCSID("@(#)$Id: strerror.c,v 1.21 2001/06/17 21:31:41 ca Exp $")
+SM_RCSID("@(#)$Id: strerror.c,v 1.24 2013-11-22 20:51:43 ca Exp $")
 
 /*
 **  define strerror for platforms that lack it.
--- old/usr/src/cmd/sendmail/libsm/strexit.c	Sat Feb  6 15:36:39 2016
+++ new/usr/src/cmd/sendmail/libsm/strexit.c	Sat Feb  6 15:36:39 2016
@@ -1,5 +1,5 @@
 /*
- * Copyright (c) 2001 Sendmail, Inc. and its suppliers.
+ * Copyright (c) 2001 Proofpoint, Inc. and its suppliers.
  *	All rights reserved.
  *
  * By using this file, you agree to the terms and conditions set
@@ -7,10 +7,8 @@
  * the sendmail distribution.
  */
 
-#pragma ident	"%Z%%M%	%I%	%E% SMI"
-
 #include <sm/gen.h>
-SM_RCSID("@(#)$Id: strexit.c,v 1.3 2001/01/15 18:39:11 ca Exp $")
+SM_RCSID("@(#)$Id: strexit.c,v 1.6 2013-11-22 20:51:43 ca Exp $")
 #include <sm/string.h>
 #include <sm/sysexits.h>
 
--- old/usr/src/cmd/sendmail/libsm/string.c	Sat Feb  6 15:36:39 2016
+++ new/usr/src/cmd/sendmail/libsm/string.c	Sat Feb  6 15:36:39 2016
@@ -1,5 +1,5 @@
 /*
- * Copyright (c) 2001 Sendmail, Inc. and its suppliers.
+ * Copyright (c) 2001 Proofpoint, Inc. and its suppliers.
  *      All rights reserved.
  *
  * By using this file, you agree to the terms and conditions set
@@ -8,10 +8,8 @@
  *
  */
 
-#pragma ident	"%Z%%M%	%I%	%E% SMI"
-
 #include <sm/gen.h>
-SM_RCSID("@(#)$Id: string.c,v 1.1 2001/02/15 21:04:50 ca Exp $")
+SM_RCSID("@(#)$Id: string.c,v 1.4 2013-11-22 20:51:43 ca Exp $")
 
 #include <ctype.h>
 #include <errno.h>
--- old/usr/src/cmd/sendmail/libsm/stringf.c	Sat Feb  6 15:36:39 2016
+++ new/usr/src/cmd/sendmail/libsm/stringf.c	Sat Feb  6 15:36:39 2016
@@ -1,5 +1,5 @@
 /*
- * Copyright (c) 2000-2001 Sendmail, Inc. and its suppliers.
+ * Copyright (c) 2000-2001 Proofpoint, Inc. and its suppliers.
  *	All rights reserved.
  *
  * By using this file, you agree to the terms and conditions set
@@ -7,10 +7,8 @@
  * the sendmail distribution.
  */
 
-#pragma ident	"%Z%%M%	%I%	%E% SMI"
-
 #include <sm/gen.h>
-SM_RCSID("@(#)$Id: stringf.c,v 1.13 2001/03/03 03:40:43 ca Exp $")
+SM_RCSID("@(#)$Id: stringf.c,v 1.16 2013-11-22 20:51:43 ca Exp $")
 #include <errno.h>
 #include <stdio.h>
 #include <sm/exc.h>
--- old/usr/src/cmd/sendmail/libsm/strio.c	Sat Feb  6 15:36:39 2016
+++ new/usr/src/cmd/sendmail/libsm/strio.c	Sat Feb  6 15:36:39 2016
@@ -1,5 +1,5 @@
 /*
- * Copyright (c) 2000-2002, 2004, 2005 Sendmail, Inc. and its suppliers.
+ * Copyright (c) 2000-2002, 2004, 2005 Proofpoint, Inc. and its suppliers.
  *      All rights reserved.
  * Copyright (c) 1990, 1993
  *	The Regents of the University of California.  All rights reserved.
@@ -12,10 +12,8 @@
  * the sendmail distribution.
  */
 
-#pragma ident	"%Z%%M%	%I%	%E% SMI"
-
 #include <sm/gen.h>
-SM_IDSTR(id, "@(#)$Id: strio.c,v 1.44 2005/06/09 21:40:19 ca Exp $")
+SM_IDSTR(id, "@(#)$Id: strio.c,v 1.45 2013-11-22 20:51:43 ca Exp $")
 #include <stdlib.h>
 #include <unistd.h>
 #include <fcntl.h>
--- old/usr/src/cmd/sendmail/libsm/strl.c	Sat Feb  6 15:36:39 2016
+++ new/usr/src/cmd/sendmail/libsm/strl.c	Sat Feb  6 15:36:39 2016
@@ -1,5 +1,5 @@
 /*
- * Copyright (c) 1999-2002 Sendmail, Inc. and its suppliers.
+ * Copyright (c) 1999-2002 Proofpoint, Inc. and its suppliers.
  *	All rights reserved.
  *
  * By using this file, you agree to the terms and conditions set
@@ -8,10 +8,8 @@
  *
  */
 
-#pragma ident	"%Z%%M%	%I%	%E% SMI"
-
 #include <sm/gen.h>
-SM_RCSID("@(#)$Id: strl.c,v 1.31 2002/01/20 01:41:25 gshapiro Exp $")
+SM_RCSID("@(#)$Id: strl.c,v 1.32 2013-11-22 20:51:43 ca Exp $")
 #include <sm/config.h>
 #include <sm/string.h>
 
--- old/usr/src/cmd/sendmail/libsm/strrevcmp.c	Sat Feb  6 15:36:39 2016
+++ new/usr/src/cmd/sendmail/libsm/strrevcmp.c	Sat Feb  6 15:36:39 2016
@@ -1,5 +1,5 @@
 /*
- * Copyright (c) 2001 Sendmail, Inc. and its suppliers.
+ * Copyright (c) 2001 Proofpoint, Inc. and its suppliers.
  *	All rights reserved.
  *
  * By using this file, you agree to the terms and conditions set
@@ -8,10 +8,8 @@
  *
  */
 
-#pragma ident	"%Z%%M%	%I%	%E% SMI"
-
 #include <sm/gen.h>
-SM_RCSID("@(#)$Id: strrevcmp.c,v 1.2 2001/08/27 22:21:51 gshapiro Exp $")
+SM_RCSID("@(#)$Id: strrevcmp.c,v 1.6 2013-11-22 20:51:43 ca Exp $")
 
 #include <sm/config.h>
 #include <sm/string.h>
@@ -62,7 +60,7 @@
 				charmap[(unsigned char) s2[i2]]);
 	}
 }
-/*
+/*
 **  SM_STRREVCMP -- compare two strings starting at the end
 **
 **	Parameters:
--- old/usr/src/cmd/sendmail/libsm/strto.c	Sat Feb  6 15:36:39 2016
+++ new/usr/src/cmd/sendmail/libsm/strto.c	Sat Feb  6 15:36:39 2016
@@ -1,5 +1,5 @@
 /*
- * Copyright (c) 2000-2001 Sendmail, Inc. and its suppliers.
+ * Copyright (c) 2000-2001 Proofpoint, Inc. and its suppliers.
  *      All rights reserved.
  * Copyright (c) 1992
  *	The Regents of the University of California.  All rights reserved.
@@ -9,10 +9,8 @@
  * the sendmail distribution.
  */
 
-#pragma ident	"%Z%%M%	%I%	%E% SMI"
-
 #include <sm/gen.h>
-SM_IDSTR(id, "@(#)$Id: strto.c,v 1.18 2001/12/30 04:59:37 gshapiro Exp $")
+SM_IDSTR(id, "@(#)$Id: strto.c,v 1.19 2013-11-22 20:51:43 ca Exp $")
 
 #include <sys/param.h>
 #include <sys/types.h>
--- old/usr/src/cmd/sendmail/libsm/t-event.c	Sat Feb  6 15:36:40 2016
+++ new/usr/src/cmd/sendmail/libsm/t-event.c	Sat Feb  6 15:36:40 2016
@@ -1,5 +1,5 @@
 /*
- * Copyright (c) 2001-2002, 2004 Sendmail, Inc. and its suppliers.
+ * Copyright (c) 2001-2002, 2004 Proofpoint, Inc. and its suppliers.
  *      All rights reserved.
  *
  * By using this file, you agree to the terms and conditions set
@@ -7,10 +7,8 @@
  * the sendmail distribution.
  */
 
-#pragma ident	"%Z%%M%	%I%	%E% SMI"
-
 #include <sm/gen.h>
-SM_RCSID("@(#)$Id: t-event.c,v 1.13 2005/06/14 23:07:20 ca Exp $")
+SM_RCSID("@(#)$Id: t-event.c,v 1.14 2013-11-22 20:51:43 ca Exp $")
 
 #include <stdio.h>
 
--- old/usr/src/cmd/sendmail/libsm/t-exc.c	Sat Feb  6 15:36:40 2016
+++ new/usr/src/cmd/sendmail/libsm/t-exc.c	Sat Feb  6 15:36:40 2016
@@ -1,5 +1,5 @@
 /*
- * Copyright (c) 2000-2001 Sendmail, Inc. and its suppliers.
+ * Copyright (c) 2000-2001 Proofpoint, Inc. and its suppliers.
  *	All rights reserved.
  *
  * By using this file, you agree to the terms and conditions set
@@ -7,10 +7,8 @@
  * the sendmail distribution.
  */
 
-#pragma ident	"%Z%%M%	%I%	%E% SMI"
-
 #include <sm/gen.h>
-SM_IDSTR(id, "@(#)$Id: t-exc.c,v 1.18 2001/07/05 22:46:35 gshapiro Exp $")
+SM_IDSTR(id, "@(#)$Id: t-exc.c,v 1.21 2013-11-22 20:51:43 ca Exp $")
 
 #include <string.h>
 #include <sm/heap.h>
--- /dev/null	Sat Feb  6 15:36:40 2016
+++ new/usr/src/cmd/sendmail/libsm/t-fget.c	Sat Feb  6 15:36:40 2016
@@ -0,0 +1,86 @@
+/*
+ * Copyright (c) 2013 Proofpoint, Inc. and its suppliers.
+ *	All rights reserved.
+ *
+ * By using this file, you agree to the terms and conditions set
+ * forth in the LICENSE file which can be found at the top level of
+ * the sendmail distribution.
+ */
+
+#include <sm/gen.h>
+SM_IDSTR(id, "@(#)$Id: t-fget.c,v 1.2 2013-11-22 20:51:43 ca Exp $")
+
+#include <sm/io.h>
+#include <sm/string.h>
+#include <sm/test.h>
+#include <errno.h>
+
+void
+check(char *msg, int l)
+{
+	SM_FILE_T *wfp, *rfp;
+	char buf[256];
+	size_t n;
+	int r, i;
+	static char fn[] = "tfget";
+
+	wfp = sm_io_open(SmFtStdio, SM_TIME_DEFAULT, fn,
+			   SM_IO_WRONLY_B, NULL);
+	SM_TEST(wfp != NULL);
+	for (i = 0; i < l; i++)
+	{
+		r = sm_io_putc(wfp, SM_TIME_DEFAULT, msg[i]);
+		SM_TEST(r >= 0);
+	}
+	r = sm_io_close(wfp, SM_TIME_DEFAULT);
+	SM_TEST(r == 0);
+
+	rfp = sm_io_open(SmFtStdio, SM_TIME_DEFAULT, fn,
+			   SM_IO_RDONLY_B, NULL);
+	SM_TEST(rfp != NULL);
+	n = sizeof(buf);
+	r = sm_io_fgets(rfp, SM_TIME_DEFAULT, buf, n);
+	if (l == 0)
+	{
+		SM_TEST(r == -1);
+		SM_TEST(errno == 0);
+	}
+	else
+	{
+		SM_TEST(r == l);
+		if (r != l)
+			fprintf(stderr, "buf='%s', in='%s', r=%d, l=%d\n",
+				buf, msg, r, l);
+	}
+	SM_TEST(memcmp(buf, msg, l) == 0);
+	r = sm_io_close(rfp, SM_TIME_DEFAULT);
+	SM_TEST(r == 0);
+}
+
+
+int
+main(argc, argv)
+	int argc;
+	char **argv;
+{
+	char res[256];
+	int l;
+
+	sm_test_begin(argc, argv, "test fget");
+
+	check("", strlen(""));
+	check("\n", strlen("\n"));
+	check("test\n", strlen("test\n"));
+
+	l = snprintf(res, sizeof(res), "%c%s\n", '\0', "test ing");
+	check(res, l);
+
+	l = snprintf(res, sizeof(res), "%c%s%c\n", '\0', "test ing", '\0');
+	check(res, l);
+
+	l = snprintf(res, sizeof(res), "%c%s%c%s\n",
+		'\0', "test ing", '\0', "eol");
+	check(res, l);
+
+	return sm_test_end();
+}
--- old/usr/src/cmd/sendmail/libsm/t-float.c	Sat Feb  6 15:36:40 2016
+++ new/usr/src/cmd/sendmail/libsm/t-float.c	Sat Feb  6 15:36:40 2016
@@ -1,5 +1,5 @@
 /*
- * Copyright (c) 2000-2001 Sendmail, Inc. and its suppliers.
+ * Copyright (c) 2000-2001 Proofpoint, Inc. and its suppliers.
  *	All rights reserved.
  *
  * By using this file, you agree to the terms and conditions set
@@ -7,10 +7,8 @@
  * the sendmail distribution.
  */
 
-#pragma ident	"%Z%%M%	%I%	%E% SMI"
-
 #include <sm/gen.h>
-SM_IDSTR(id, "@(#)$Id: t-float.c,v 1.16 2001/02/02 23:11:46 ca Exp $")
+SM_IDSTR(id, "@(#)$Id: t-float.c,v 1.19 2013-11-22 20:51:43 ca Exp $")
 
 #include <sm/limits.h>
 #include <sm/io.h>
--- old/usr/src/cmd/sendmail/libsm/t-fopen.c	Sat Feb  6 15:36:40 2016
+++ new/usr/src/cmd/sendmail/libsm/t-fopen.c	Sat Feb  6 15:36:40 2016
@@ -1,5 +1,5 @@
 /*
- * Copyright (c) 2000-2002 Sendmail, Inc. and its suppliers.
+ * Copyright (c) 2000-2002 Proofpoint, Inc. and its suppliers.
  *	All rights reserved.
  *
  * By using this file, you agree to the terms and conditions set
@@ -7,10 +7,8 @@
  * the sendmail distribution.
  */
 
-#pragma ident	"%Z%%M%	%I%	%E% SMI"
-
 #include <sm/gen.h>
-SM_IDSTR(id, "@(#)$Id: t-fopen.c,v 1.9 2002/02/06 23:57:45 ca Exp $")
+SM_IDSTR(id, "@(#)$Id: t-fopen.c,v 1.10 2013-11-22 20:51:43 ca Exp $")
 
 #include <fcntl.h>
 #include <sm/io.h>
--- old/usr/src/cmd/sendmail/libsm/t-heap.c	Sat Feb  6 15:36:40 2016
+++ new/usr/src/cmd/sendmail/libsm/t-heap.c	Sat Feb  6 15:36:40 2016
@@ -1,5 +1,5 @@
 /*
- * Copyright (c) 2000-2001 Sendmail, Inc. and its suppliers.
+ * Copyright (c) 2000-2001 Proofpoint, Inc. and its suppliers.
  *	All rights reserved.
  *
  * By using this file, you agree to the terms and conditions set
@@ -7,10 +7,8 @@
  * the sendmail distribution.
  */
 
-#pragma ident	"%Z%%M%	%I%	%E% SMI"
-
 #include <sm/gen.h>
-SM_IDSTR(id, "@(#)$Id: t-heap.c,v 1.8 2001/03/06 17:27:36 ca Exp $")
+SM_IDSTR(id, "@(#)$Id: t-heap.c,v 1.11 2013-11-22 20:51:43 ca Exp $")
 
 #include <sm/debug.h>
 #include <sm/heap.h>
--- old/usr/src/cmd/sendmail/libsm/t-match.c	Sat Feb  6 15:36:40 2016
+++ new/usr/src/cmd/sendmail/libsm/t-match.c	Sat Feb  6 15:36:40 2016
@@ -1,5 +1,5 @@
 /*
- * Copyright (c) 2000 Sendmail, Inc. and its suppliers.
+ * Copyright (c) 2000 Proofpoint, Inc. and its suppliers.
  *	All rights reserved.
  *
  * By using this file, you agree to the terms and conditions set
@@ -7,10 +7,8 @@
  * the sendmail distribution.
  */
 
-#pragma ident	"%Z%%M%	%I%	%E% SMI"
-
 #include <sm/gen.h>
-SM_IDSTR(id, "@(#)$Id: t-match.c,v 1.7 2000/12/18 18:12:12 ca Exp $")
+SM_IDSTR(id, "@(#)$Id: t-match.c,v 1.10 2013-11-22 20:51:43 ca Exp $")
 
 #include <sm/string.h>
 #include <sm/io.h>
--- old/usr/src/cmd/sendmail/libsm/t-memstat.c	Sat Feb  6 15:36:40 2016
+++ new/usr/src/cmd/sendmail/libsm/t-memstat.c	Sat Feb  6 15:36:40 2016
@@ -1,5 +1,5 @@
 /*
- * Copyright (c) 2005-2007 Sendmail, Inc. and its suppliers.
+ * Copyright (c) 2005-2007 Proofpoint, Inc. and its suppliers.
  *      All rights reserved.
  *
  * By using this file, you agree to the terms and conditions set
@@ -7,10 +7,8 @@
  * the sendmail distribution.
  */
 
-#pragma ident	"%Z%%M%	%I%	%E% SMI"
-
 #include <sm/gen.h>
-SM_IDSTR(id, "@(#)$Id: t-memstat.c,v 1.9 2007/03/14 21:41:09 ca Exp $")
+SM_IDSTR(id, "@(#)$Id: t-memstat.c,v 1.11 2013-11-22 20:51:43 ca Exp $")
 
 #include <sm/misc.h>
 
@@ -65,6 +63,12 @@
 
 		  case 'r':
 			resource = strdup(optarg);
+			if (resource == NULL)
+			{
+				fprintf(stderr, "strdup(%s) failed\n",
+					optarg);
+				exit(1);
+			}
 			break;
 
 		  case 's':
--- old/usr/src/cmd/sendmail/libsm/t-path.c	Sat Feb  6 15:36:40 2016
+++ new/usr/src/cmd/sendmail/libsm/t-path.c	Sat Feb  6 15:36:40 2016
@@ -1,5 +1,5 @@
 /*
- * Copyright (c) 2000-2001 Sendmail, Inc. and its suppliers.
+ * Copyright (c) 2000-2001 Proofpoint, Inc. and its suppliers.
  *	All rights reserved.
  *
  * By using this file, you agree to the terms and conditions set
@@ -7,10 +7,8 @@
  * the sendmail distribution.
  */
 
-#pragma ident	"%Z%%M%	%I%	%E% SMI"
-
 #include <sm/gen.h>
-SM_IDSTR(id, "@(#)$Id: t-path.c,v 1.6 2001/07/05 22:47:29 gshapiro Exp $")
+SM_IDSTR(id, "@(#)$Id: t-path.c,v 1.9 2013-11-22 20:51:43 ca Exp $")
 
 #include <string.h>
 #include <sm/path.h>
--- old/usr/src/cmd/sendmail/libsm/t-qic.c	Sat Feb  6 15:36:40 2016
+++ new/usr/src/cmd/sendmail/libsm/t-qic.c	Sat Feb  6 15:36:40 2016
@@ -1,5 +1,5 @@
 /*
- * Copyright (c) 2006 Sendmail, Inc. and its suppliers.
+ * Copyright (c) 2006 Proofpoint, Inc. and its suppliers.
  *	All rights reserved.
  *
  * By using this file, you agree to the terms and conditions set
@@ -7,10 +7,8 @@
  * the sendmail distribution.
  */
 
-#pragma ident	"%Z%%M%	%I%	%E% SMI"
-
 #include <sm/gen.h>
-SM_IDSTR(id, "@(#)$Id: t-qic.c,v 1.9 2006/08/24 21:26:13 ca Exp $")
+SM_IDSTR(id, "@(#)$Id: t-qic.c,v 1.10 2013-11-22 20:51:43 ca Exp $")
 
 #include <stdio.h>
 #include <sm/sendmail.h>
--- old/usr/src/cmd/sendmail/libsm/t-rpool.c	Sat Feb  6 15:36:40 2016
+++ new/usr/src/cmd/sendmail/libsm/t-rpool.c	Sat Feb  6 15:36:40 2016
@@ -1,5 +1,5 @@
 /*
- * Copyright (c) 2000-2001 Sendmail, Inc. and its suppliers.
+ * Copyright (c) 2000-2001 Proofpoint, Inc. and its suppliers.
  *	All rights reserved.
  *
  * By using this file, you agree to the terms and conditions set
@@ -7,10 +7,8 @@
  * the sendmail distribution.
  */
 
-#pragma ident	"%Z%%M%	%I%	%E% SMI"
-
 #include <sm/gen.h>
-SM_IDSTR(id, "@(#)$Id: t-rpool.c,v 1.16 2001/03/04 18:38:47 ca Exp $")
+SM_IDSTR(id, "@(#)$Id: t-rpool.c,v 1.19 2013-11-22 20:51:43 ca Exp $")
 
 #include <sm/debug.h>
 #include <sm/heap.h>
--- old/usr/src/cmd/sendmail/libsm/t-scanf.c	Sat Feb  6 15:36:40 2016
+++ new/usr/src/cmd/sendmail/libsm/t-scanf.c	Sat Feb  6 15:36:40 2016
@@ -1,5 +1,5 @@
 /*
- * Copyright (c) 2001 Sendmail, Inc. and its suppliers.
+ * Copyright (c) 2001 Proofpoint, Inc. and its suppliers.
  *	All rights reserved.
  *
  * By using this file, you agree to the terms and conditions set
@@ -7,10 +7,8 @@
  * the sendmail distribution.
  */
 
-#pragma ident	"%Z%%M%	%I%	%E% SMI"
-
 #include <sm/gen.h>
-SM_IDSTR(id, "@(#)$Id: t-scanf.c,v 1.5 2001/11/13 00:51:28 ca Exp $")
+SM_IDSTR(id, "@(#)$Id: t-scanf.c,v 1.6 2013-11-22 20:51:43 ca Exp $")
 
 #include <sm/limits.h>
 #include <sm/io.h>
--- old/usr/src/cmd/sendmail/libsm/t-sem.c	Sat Feb  6 15:36:40 2016
+++ new/usr/src/cmd/sendmail/libsm/t-sem.c	Sat Feb  6 15:36:40 2016
@@ -1,5 +1,5 @@
 /*
- * Copyright (c) 2000-2001, 2005-2008 Sendmail, Inc. and its suppliers.
+ * Copyright (c) 2000-2001, 2005-2008 Proofpoint, Inc. and its suppliers.
  *      All rights reserved.
  *
  * By using this file, you agree to the terms and conditions set
@@ -8,7 +8,7 @@
  */
 
 #include <sm/gen.h>
-SM_RCSID("@(#)$Id: t-sem.c,v 1.17 2008/05/30 16:26:38 ca Exp $")
+SM_RCSID("@(#)$Id: t-sem.c,v 1.18 2013-11-22 20:51:43 ca Exp $")
 
 #include <stdio.h>
 
--- old/usr/src/cmd/sendmail/libsm/t-shm.c	Sat Feb  6 15:36:41 2016
+++ new/usr/src/cmd/sendmail/libsm/t-shm.c	Sat Feb  6 15:36:41 2016
@@ -1,5 +1,5 @@
 /*
- * Copyright (c) 2000-2002, 2004, 2005 Sendmail, Inc. and its suppliers.
+ * Copyright (c) 2000-2002, 2004, 2005 Proofpoint, Inc. and its suppliers.
  *      All rights reserved.
  *
  * By using this file, you agree to the terms and conditions set
@@ -7,10 +7,8 @@
  * the sendmail distribution.
  */
 
-#pragma ident	"%Z%%M%	%I%	%E% SMI"
-
 #include <sm/gen.h>
-SM_RCSID("@(#)$Id: t-shm.c,v 1.22 2005/01/14 02:14:10 ca Exp $")
+SM_RCSID("@(#)$Id: t-shm.c,v 1.23 2013-11-22 20:51:43 ca Exp $")
 
 #include <stdio.h>
 
--- old/usr/src/cmd/sendmail/libsm/t-smstdio.c	Sat Feb  6 15:36:41 2016
+++ new/usr/src/cmd/sendmail/libsm/t-smstdio.c	Sat Feb  6 15:36:41 2016
@@ -1,5 +1,5 @@
 /*
- * Copyright (c) 2000-2001 Sendmail, Inc. and its suppliers.
+ * Copyright (c) 2000-2001 Proofpoint, Inc. and its suppliers.
  *	All rights reserved.
  *
  * By using this file, you agree to the terms and conditions set
@@ -7,10 +7,8 @@
  * the sendmail distribution.
  */
 
-#pragma ident	"%Z%%M%	%I%	%E% SMI"
-
 #include <sm/gen.h>
-SM_IDSTR(id, "@(#)$Id: t-smstdio.c,v 1.9 2001/03/21 18:30:41 ca Exp $")
+SM_IDSTR(id, "@(#)$Id: t-smstdio.c,v 1.12 2013-11-22 20:51:43 ca Exp $")
 
 #include <sm/io.h>
 #include <sm/string.h>
--- old/usr/src/cmd/sendmail/libsm/t-string.c	Sat Feb  6 15:36:41 2016
+++ new/usr/src/cmd/sendmail/libsm/t-string.c	Sat Feb  6 15:36:41 2016
@@ -1,5 +1,5 @@
 /*
- * Copyright (c) 2000-2001 Sendmail, Inc. and its suppliers.
+ * Copyright (c) 2000-2001 Proofpoint, Inc. and its suppliers.
  *	All rights reserved.
  *
  * By using this file, you agree to the terms and conditions set
@@ -7,10 +7,8 @@
  * the sendmail distribution.
  */
 
-#pragma ident	"%Z%%M%	%I%	%E% SMI"
-
 #include <sm/gen.h>
-SM_IDSTR(id, "@(#)$Id: t-string.c,v 1.9 2001/01/26 03:28:43 ca Exp $")
+SM_IDSTR(id, "@(#)$Id: t-string.c,v 1.12 2013-11-22 20:51:43 ca Exp $")
 
 #include <sm/exc.h>
 #include <sm/io.h>
--- old/usr/src/cmd/sendmail/libsm/t-strio.c	Sat Feb  6 15:36:41 2016
+++ new/usr/src/cmd/sendmail/libsm/t-strio.c	Sat Feb  6 15:36:41 2016
@@ -1,5 +1,5 @@
 /*
- * Copyright (c) 2000-2001 Sendmail, Inc. and its suppliers.
+ * Copyright (c) 2000-2001 Proofpoint, Inc. and its suppliers.
  *	All rights reserved.
  *
  * By using this file, you agree to the terms and conditions set
@@ -7,10 +7,8 @@
  * the sendmail distribution.
  */
 
-#pragma ident	"%Z%%M%	%I%	%E% SMI"
-
 #include <sm/gen.h>
-SM_IDSTR(id, "@(#)$Id: t-strio.c,v 1.9 2001/03/03 04:00:53 ca Exp $")
+SM_IDSTR(id, "@(#)$Id: t-strio.c,v 1.12 2013-11-22 20:51:44 ca Exp $")
 #include <sm/string.h>
 #include <sm/io.h>
 #include <sm/test.h>
--- old/usr/src/cmd/sendmail/libsm/t-strl.c	Sat Feb  6 15:36:41 2016
+++ new/usr/src/cmd/sendmail/libsm/t-strl.c	Sat Feb  6 15:36:41 2016
@@ -1,5 +1,5 @@
 /*
- * Copyright (c) 2000-2001 Sendmail, Inc. and its suppliers.
+ * Copyright (c) 2000-2001 Proofpoint, Inc. and its suppliers.
  *	All rights reserved.
  *
  * By using this file, you agree to the terms and conditions set
@@ -8,10 +8,8 @@
  *
  */
 
-#pragma ident	"%Z%%M%	%I%	%E% SMI"
-
 #include <sm/gen.h>
-SM_IDSTR(id, "@(#)$Id: t-strl.c,v 1.13 2001/08/27 23:00:05 gshapiro Exp $")
+SM_IDSTR(id, "@(#)$Id: t-strl.c,v 1.16 2013-11-22 20:51:44 ca Exp $")
 
 #include <stdlib.h>
 #include <stdio.h>
--- old/usr/src/cmd/sendmail/libsm/t-strrevcmp.c	Sat Feb  6 15:36:41 2016
+++ new/usr/src/cmd/sendmail/libsm/t-strrevcmp.c	Sat Feb  6 15:36:41 2016
@@ -1,5 +1,5 @@
 /*
- * Copyright (c) 2001 Sendmail, Inc. and its suppliers.
+ * Copyright (c) 2001 Proofpoint, Inc. and its suppliers.
  *	All rights reserved.
  *
  * By using this file, you agree to the terms and conditions set
@@ -7,10 +7,8 @@
  * the sendmail distribution.
  */
 
-#pragma ident	"%Z%%M%	%I%	%E% SMI"
-
 #include <sm/gen.h>
-SM_IDSTR(id, "@(#)$Id: t-strrevcmp.c,v 1.1 2001/07/16 21:35:28 ca Exp $")
+SM_IDSTR(id, "@(#)$Id: t-strrevcmp.c,v 1.4 2013-11-22 20:51:44 ca Exp $")
 
 #include <sm/exc.h>
 #include <sm/io.h>
--- old/usr/src/cmd/sendmail/libsm/test.c	Sat Feb  6 15:36:41 2016
+++ new/usr/src/cmd/sendmail/libsm/test.c	Sat Feb  6 15:36:41 2016
@@ -1,5 +1,5 @@
 /*
- * Copyright (c) 2000-2002 Sendmail, Inc. and its suppliers.
+ * Copyright (c) 2000-2002 Proofpoint, Inc. and its suppliers.
  *	All rights reserved.
  *
  * By using this file, you agree to the terms and conditions set
@@ -7,10 +7,8 @@
  * the sendmail distribution.
  */
 
-#pragma ident	"%Z%%M%	%I%	%E% SMI"
-
 #include <sm/gen.h>
-SM_IDSTR(Id, "@(#)$Id: test.c,v 1.16 2002/01/08 17:54:40 ca Exp $")
+SM_IDSTR(Id, "@(#)$Id: test.c,v 1.17 2013-11-22 20:51:44 ca Exp $")
 
 /*
 **  Abstractions for writing libsm test programs.
--- old/usr/src/cmd/sendmail/libsm/ungetc.c	Sat Feb  6 15:36:41 2016
+++ new/usr/src/cmd/sendmail/libsm/ungetc.c	Sat Feb  6 15:36:41 2016
@@ -1,5 +1,5 @@
 /*
- * Copyright (c) 2000-2001, 2004 Sendmail, Inc. and its suppliers.
+ * Copyright (c) 2000-2001, 2004 Proofpoint, Inc. and its suppliers.
  *      All rights reserved.
  * Copyright (c) 1990, 1993
  *	The Regents of the University of California.  All rights reserved.
@@ -12,10 +12,8 @@
  * the sendmail distribution.
  */
 
-#pragma ident	"%Z%%M%	%I%	%E% SMI"
-
 #include <sm/gen.h>
-SM_IDSTR(id, "@(#)$Id: ungetc.c,v 1.30 2005/06/14 23:07:20 ca Exp $")
+SM_IDSTR(id, "@(#)$Id: ungetc.c,v 1.31 2013-11-22 20:51:44 ca Exp $")
 
 #include <stdlib.h>
 #include <string.h>
--- old/usr/src/cmd/sendmail/libsm/util.c	Sat Feb  6 15:36:41 2016
+++ new/usr/src/cmd/sendmail/libsm/util.c	Sat Feb  6 15:36:41 2016
@@ -1,5 +1,5 @@
 /*
- * Copyright (c) 2006 Sendmail, Inc. and its suppliers.
+ * Copyright (c) 2006 Proofpoint, Inc. and its suppliers.
  *	All rights reserved.
  *
  * By using this file, you agree to the terms and conditions set
@@ -8,11 +8,9 @@
  *
  */
 
-#pragma ident	"%Z%%M%	%I%	%E% SMI"
-
 #include <sm/gen.h>
 
-SM_RCSID("@(#)$Id: util.c,v 1.9 2006/08/30 18:35:51 ca Exp $")
+SM_RCSID("@(#)$Id: util.c,v 1.10 2013-11-22 20:51:44 ca Exp $")
 #include <sm/setjmp.h>
 #include <sm/conf.h>
 #include <sm/assert.h>
--- old/usr/src/cmd/sendmail/libsm/vasprintf.c	Sat Feb  6 15:36:41 2016
+++ new/usr/src/cmd/sendmail/libsm/vasprintf.c	Sat Feb  6 15:36:41 2016
@@ -1,5 +1,5 @@
 /*
- * Copyright (c) 2000-2001 Sendmail, Inc. and its suppliers.
+ * Copyright (c) 2000-2001 Proofpoint, Inc. and its suppliers.
  *      All rights reserved.
  *
  * By using this file, you agree to the terms and conditions set
@@ -23,10 +23,8 @@
  * CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
  */
 
-#pragma ident	"%Z%%M%	%I%	%E% SMI"
-
 #include <sm/gen.h>
-SM_RCSID("@(#)$Id: vasprintf.c,v 1.26.2.1 2003/06/03 02:14:09 ca Exp $")
+SM_RCSID("@(#)$Id: vasprintf.c,v 1.28 2013-11-22 20:51:44 ca Exp $")
 #include <stdlib.h>
 #include <errno.h>
 #include <sm/io.h>
--- old/usr/src/cmd/sendmail/libsm/vfprintf.c	Sat Feb  6 15:36:41 2016
+++ new/usr/src/cmd/sendmail/libsm/vfprintf.c	Sat Feb  6 15:36:41 2016
@@ -1,5 +1,5 @@
 /*
- * Copyright (c) 2000-2001, 2004 Sendmail, Inc. and its suppliers.
+ * Copyright (c) 2000-2001, 2004 Proofpoint, Inc. and its suppliers.
  *      All rights reserved.
  * Copyright (c) 1990
  *	The Regents of the University of California.  All rights reserved.
@@ -12,10 +12,8 @@
  * the sendmail distribution.
  */
 
-#pragma ident	"%Z%%M%	%I%	%E% SMI"
-
 #include <sm/gen.h>
-SM_IDSTR(id, "@(#)$Id: vfprintf.c,v 1.54 2005/05/16 03:52:00 ca Exp $")
+SM_IDSTR(id, "@(#)$Id: vfprintf.c,v 1.55 2013-11-22 20:51:44 ca Exp $")
 
 /*
 **  Overall:
--- old/usr/src/cmd/sendmail/libsm/vfscanf.c	Sat Feb  6 15:36:41 2016
+++ new/usr/src/cmd/sendmail/libsm/vfscanf.c	Sat Feb  6 15:36:41 2016
@@ -1,5 +1,5 @@
 /*
- * Copyright (c) 2000-2001, 2004 Sendmail, Inc. and its suppliers.
+ * Copyright (c) 2000-2001, 2004 Proofpoint, Inc. and its suppliers.
  *      All rights reserved.
  * Copyright (c) 1990, 1993
  *	The Regents of the University of California.  All rights reserved.
@@ -12,10 +12,8 @@
  * the sendmail distribution.
  */
 
-#pragma ident	"%Z%%M%	%I%	%E% SMI"
-
 #include <sm/gen.h>
-SM_IDSTR(id, "@(#)$Id: vfscanf.c,v 1.54 2006/10/12 22:03:52 ca Exp $")
+SM_IDSTR(id, "@(#)$Id: vfscanf.c,v 1.55 2013-11-22 20:51:44 ca Exp $")
 
 #include <ctype.h>
 #include <stdlib.h>
